<script setup>

  import {ref} from 'vue';
  
  let todoList = ref([]);
  let todo = ref(null);
  let selectedTodo = ref(null);

  //for selecting a todo in the todoList
  const selectTodo = (row) => {
    selectedTodo.value = row;
    todo.value = row.todo;
  }

  //for adding a new todo in the todoList
  const addTodo = () => {
    if(validateTodo(todo.value)) {
      let id = todoList.value.length;
      todoList.value.push({
        id: ++id,
        todo: todo.value,
        is_done: false
      })
      todo.value = null
    }
  }

  //for checking if there are any duplicates in the todoList
  const validateTodo = (new_todo) => {
    let index = todoList.value.findIndex((t) => t.todo === new_todo);
    if (index !== -1) {
      alert("Todo already exists!");
      return false;
    } else {
      return true;
    }
  }

  //for updating the value or name of the todo
  const updateTodo = () => {
    if (validateTodo(todo.value)) {
      let index = todoList.value.findIndex((t) => t.id === selectedTodo.value.id);
      index !== -1 && (todoList.value[index].todo = todo.value);
      todo.value = selectedTodo.value = null;
    }
  }

  //for completing a todo
  const markAsDone = (row) => {
    if(confirm(`Are you sure you want to mark ${row.todo} as done?`)) {
      let index = todoList.value.findIndex((t) => t.id === row.id);
      index !== -1 && (todoList.value[index].is_done = true);
    }
  }

  //for deleting a todo
  const removeTodo = (row) => {
    if(confirm(`Are you sure you want to delete ${row.todo}?`)) {
      let index = todoList.value.findIndex((t) => t.id === row.id);
      index !== -1 && todoList.value.splice(index, 1);
    }
  }
</script>

<template>
  <div class="d-flex justify-content-center container">
    <div class="w-75">
      <!--If there is no Todo selected, it will do addToDo, otherwise updateTodo-->
      <form @submit.prevent="!selectedTodo ? addTodo() : updateTodo()">
        <div class="mb-3 mt-5">
          <label for="todo">What's your todo?</label>
          <div class="d-flex">
            <input v-model="todo" type="text" class="form-control" id="todo" placeholder="e.g. Create todo application">
            <!--dynamic button, if there is no Todo selected the first button will appear and the other button will vanish and vice-versa-->
            <button v-if="!selectedTodo" class="btn btn-primary ms-3"><i class="bi bi-plus-circle-fill"></i></button>
            <button v-else class="btn btn-primary ms-3"><i class="bi bi-pencil-square"></i></button>
          </div>
        </div>
      </form>
      <!--When a todo is clicked, selectedTodo gets triggered-->
      <div @click="selectTodo(row)" v-for="row in todoList" :key="row.id" class="toast show mt-2 w-100">
        <div class="toast-header">
          <!--dynamically list the existing todo-->
          <strong class="me-auto">{{ row.todo }}</strong>
          <!--if the todo is completed, it will add the class success to btn-, otherwise it will add outline-secondary -->
          <button :class="`btn btn-${row.is_done ? 'success' : 'outline-secondary'} btn-sm`" @click.stop="markAsDone(row)"><i class="bi bi-check-lg"></i></button>
          <!--if button is clicked, triggers removeTodo which deletes the todo-->
          <button class="btn btn-danger btn-sm ms-1" @click.stop="removeTodo(row)"><i class="bi bi-trash-fill"></i></button>
        </div>
      </div>
    </div>
  </div>
</template>

<style scoped>
</style>
